﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PsiKeepers
{
    public partial class FormMain : Form
    {
        private Controls m_controls;
        private Game m_game;

        public FormMain()
        {
            InitializeComponent();

            Game.ScreenSize = new PointF(ClientSize.Width, ClientSize.Height);

            m_controls = new Controls();
            m_game = new Game();
        }

        private void FormMain_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            g.Clear(Color.Black);

            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;

            m_game.Draw(g, m_controls);
        }

        private void timerMain_Tick(object sender, EventArgs e)
        {
            if (!Focused) 
                m_controls.Reset();

            m_game.Update((float)timerMain.Interval / 1000.0f, m_controls);
            Invalidate();
        }

        private void FormMain_KeyDown(object sender, KeyEventArgs e)
        {
            HandleKey(e.KeyCode, true);
        }

        private void FormMain_KeyUp(object sender, KeyEventArgs e)
        {
            HandleKey(e.KeyCode, false);
        }

        private void HandleKey(Keys key, bool is_down)
        {
            switch (key)
            {
                case Keys.A:
                case Keys.Left:
                    m_controls.plr_move_left = is_down;
                    break;

                case Keys.D:
                case Keys.Right:
                    m_controls.plr_move_right = is_down;
                    break;

                case Keys.W:
                case Keys.Up:
                    m_controls.plr_move_up = is_down;
                    break;

                case Keys.S:
                case Keys.Down:
                    m_controls.plr_move_down = is_down;
                    break;
            }
        }

        private void FormMain_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
                m_controls.mouse_left = true;

            m_controls.mouse_pos.X = e.X;
            m_controls.mouse_pos.Y = e.Y;
        }

        private void FormMain_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
                m_controls.mouse_left = false;

            m_controls.mouse_pos.X = e.X;
            m_controls.mouse_pos.Y = e.Y;
        }

        private void FormMain_MouseMove(object sender, MouseEventArgs e)
        {
            m_controls.mouse_pos.X = e.X;
            m_controls.mouse_pos.Y = e.Y;
        }
    }
}
