﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PsiKeepers
{
    public static class MathUtil
    {
        public const float PI = (float)Math.PI;
        public const float PI2 = PI * 2.0f;

        public static float Deg2Rad(float deg)
        {
            return (deg * PI / 180.0f);
        }

        public static float Rad2Deg(float rad)
        {
            return (rad * 180.0f / PI);
        }

        public static float WrapRange(float v, float min, float max)
        {
            float range = max - min;
            while (v < min)
                v += range;
            while (v > max)
                v -= range;
            return v;
        }

        public static int Clamp(int v, int min, int max)
        {
            return (v < min) ? min : ((v > max) ? max : v);
        }

        public static float Clamp(float v, float min, float max)
        {
            return (v < min) ? min : ((v > max) ? max : v);
        }

        public static float Lerp(float from, float to, float t)
        {
            return from + t * (to - from);
        }

        public static float AngleDiff(float rad1, float rad2)
        {
            rad1 = WrapRange(rad1, 0, PI2);
            rad2 = WrapRange(rad2, 0, PI2);
            return WrapRange(rad2 - rad1, -PI, PI);
        }
    }
}
