﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Media;
using System.Reflection;
using System.Text;

namespace PsiKeepers
{
    public class Sounds
    {
        public SoundPlayer sound_click;
        public SoundPlayer sound_misclick;
        public SoundPlayer sound_expl1;
        public SoundPlayer sound_expl2;
        public SoundPlayer sound_expl3;
        public SoundPlayer sound_expl4;
        public SoundPlayer sound_under_control;

        public Sounds()
        {
            sound_click = NewPlayer("click.wav");
            sound_misclick = NewPlayer("misclick.wav");
            sound_expl1 = NewPlayer("expl1.wav");
            sound_expl2 = NewPlayer("expl2.wav");
            sound_expl3 = NewPlayer("expl3.wav");
            sound_expl4 = NewPlayer("expl4.wav");
            sound_under_control = NewPlayer("under_control.wav");
        }

        private SoundPlayer NewPlayer(string fname)
        {
            Assembly asm = Assembly.GetExecutingAssembly();
            string[] resources = asm.GetManifestResourceNames();
            using (Stream stm = asm.GetManifestResourceStream("PsiKeepers.Sounds." + fname))
            {
                SoundPlayer player = new SoundPlayer(stm);
                player.Load();
                return player;
            }
        }
    }
}
